#include "mbed.h"
#include "extern.h"

//line
void ReadLine(void){
    static uint8_t line_buf[3]={0,0,0};
    wait_us(100);
    if(Line[0].read()==1) line_buf[0] = 100;
    if(line_buf[0]==0)  data.lnFlag[0]=0;
    else                data.lnFlag[0]=1;
    if(line_buf[0]>0) line_buf[0]--;
    
    if(Line[1].read()==1) line_buf[1] = 100;
    if(line_buf[1]==0)  data.lnFlag[1]=0;
    else                data.lnFlag[1]=1;
    if(line_buf[1]>0) line_buf[1]--;
    
    if(Line[2].read()==1) line_buf[2] = 100;
    if(line_buf[2]==0)  data.lnFlag[2]=0;
    else                data.lnFlag[2]=1;
    if(line_buf[2]>0) line_buf[2]--;
}
//ball
uint8_t ReadBall(void){//1or0
    data.ball = !BallChecker;
    return (data.ball>0); 
}
void ReadMouse(void){
    if(mouse_sensor.new_motion_data_available()) 
    {
        int16_t delta_x = 0, delta_y = 0;
        mouse_sensor.get_delta_x_y(delta_x, delta_y);
        data.mouse[0] += delta_x;
        data.mouse[1] += delta_y;
    }
}
void ReadGyro(void){
    //Data can be got by interrupt.
}
void ReadCmps(void){
    data.cmps = hmc.sample()/10.0;
}
void ReadPing(void){
    uint16_t spi_data;
    //Ultra Sonic Wave
    spi_ss[1]=0;
    wait_us(200);
    
    spi_data = spi.write(0xABCD);
    
    wait_us(200);
    spi_ss[1]=1;
    
    data.ping[0] = (spi_data&0x00FF)>>0;
    data.ping[1] = (spi_data&0xFF00)>>8;
}
void ValidIr(void){
    if(data.IrFlag==0){
        data.IrFlag=1;
    }
}
void ReadIr(void){
    uint16_t spi_data;
    
    //Ir
    spi_ss[3]=0;
    wait_us(200);
    
    spi_data = spi.write(0xABCD);
    
    wait_us(200);
    spi_ss[3]=1;
    //key/notice/long/short
    data.irKey = (spi_data&0xF000)>>12;
    data.irNotice = (spi_data&0x0F00)>>8;
    data.irSpot[IR_LONG] = (spi_data&0x00F0)>>4;
    data.irSpot[IR_SHORT] = (spi_data&0x000F)>>0;
    
    if(data.irKey!=0xA) data.irNotice=IR_NONE;
    if(data.irNotice == IR_NONE) data.irPosition=11;
    if(data.irNotice == IR_FAR) data.irPosition=data.irSpot[IR_LONG]-1;
    if(data.irNotice == IR_CLOSE) data.irPosition=data.irSpot[IR_SHORT]+7;
    if(data.irNotice == IR_CLOSER) data.irPosition=data.irSpot[IR_SHORT]+7;
}
void ReadInfo(void){
    
}